#<profile4xi profile = "31"/>
#<program4xi program = "generate2event4scope.py">
#<abstract4xi abstract = "generates event programs to events from virtual dragon event"/>
#<refer4xi reference = "Studio4Xi"/>
#<note4xi note = "steps required before running this module"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'generate2event4scope' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os,sys,string
import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Studio4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI
from version4xi import ActKB4scope 
#"
#/>
# -------------------------------------------------------------------------------------------------
# Multiprocessing4xi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from actor2a4xi import Actor2a4Xi                                                                                  
from actor2b4xi import Actor2b4Xi                                                                                   
from actor2c4xi import Actor2c4Xi
from actor2d4xi import Actor2d4Xi
from actor2e4xi import Actor2e4Xi
from actor2f4xi import Actor2f4Xi
from actor2g4xi import Actor2g4Xi
from actor2h4xi import Actor2h4Xi
from actor2i4xi import Actor2i4Xi
from actor2j4xi import Actor2j4Xi
from actor2k4xi import Actor2k4Xi
from actor2l4xi import Actor2l4Xi
from actor2m4xi import Actor2m4Xi
from actor2n4xi import Actor2n4Xi
from actor2o4xi import Actor2o4Xi
from actor2p4xi import Actor2p4Xi
from actor2q4xi import Actor2q4Xi
from actor2r4xi import Actor2r4Xi
from actor2s4xi import Actor2s4Xi
from actor2t4xi import Actor2t4Xi
from actor2u4xi import Actor2u4Xi
from actor2v4xi import Actor2v4Xi
from actor2w4xi import Actor2w4Xi
from actor2x4xi import Actor2x4Xi
from actor2y4xi import Actor2y4Xi
from actor2z4xi import Actor2z4Xi
from actor2_4xi import Actor2_4Xi
from pickle4xi import pickle4xi                                                                                   
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi 
from print4xi import print4xi
from print4xi import Print4Xi 
from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi                                                                   
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# Globals                            
# -------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

global kb2keep                               
global kb2tailor                             
global kb2write                              

global path2temp4source  
global path2read4xi                          
global path2write4xi                         

global PickleKB4Xi
global profile2fetch                         
global t2xi 
global trace_object_count

#"
#"/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "

# -------------------------------------------------------------------------------------------------
# KNOWLEDGEBASE FOR WRITING CONTAINING FILE OBJECTS
# -------------------------------------------------------------------------------------------------                                                                                           
kb2write = {} 


# -------------------------------------------------------------------------------------------------
# DEFINE SEARCH PATTERNS - MAX 8 PER PATTERN FOR ONE LINE
# -------------------------------------------------------------------------------------------------
kb2search = {}                               # search patterns
kb2search[1] = {}                            # first search pattern
kb2search[1] [1]      = "dragon"             # max 8 in each line 
kb2search[1] [2]      = "dragon" 
kb2search[1] [3]      = "dragon" 
kb2search[1] [4]      = "dragon" 
kb2search[1] [5]      = "dragon" 
kb2search[1] [6]      = "dragon" 
kb2search[1] [7]      = "dragon" 
kb2search[1] [8]      = "dragon" 

kb2search[2] = {}                            # second search pattern
kb2search[2] [1]      = "DRAGON"             # max 8 in each line 
kb2search[2] [2]      = "DRAGON"
kb2search[2] [3]      = "DRAGON"
kb2search[2] [4]      = "DRAGON"
kb2search[2] [5]      = "DRAGON"
kb2search[2] [6]      = "DRAGON"
kb2search[2] [7]      = "DRAGON"
kb2search[2] [8]      = "DRAGON"

                                                                                           
# --------------------------------------------------------------------------------------------------
# KNOWLEDGEBASE FOR TAILORING
# 
# --------------------------------------------------------------------------------------------------                                                                                           
kb2tailor = {}
kb2tailor ['a'] = {}
kb2tailor ['a'] ['module'] = 'apu2event4xi5test.py'
kb2tailor ['a'] ['dragon'] = 'apu'
kb2tailor ['a'] ['DRAGON'] = 'APU'
kb2tailor ['a'] ['line']   = 'default: line not generated from input'
kb2tailor ['b'] = {}
kb2tailor ['b'] ['module'] = 'bpu2event4xi5test.py'
kb2tailor ['b'] ['dragon'] = 'bpu'
kb2tailor ['b'] ['DRAGON'] = 'BPU'
kb2tailor ['b'] ['line']   = 'default: line not generated from input'
kb2tailor ['c'] = {}
kb2tailor ['c'] ['module'] = 'cpu2event4xi5test.py'
kb2tailor ['c'] ['dragon'] = 'cpu'
kb2tailor ['c'] ['DRAGON'] = 'CPU'
kb2tailor ['c'] ['line']   = 'default: line not generated from input'
kb2tailor ['d'] = {}
kb2tailor ['d'] ['module'] = 'dpu2event4xi5test.py'
kb2tailor ['d'] ['dragon'] = 'dpu'
kb2tailor ['d'] ['DRAGON'] = 'DPU'
kb2tailor ['d'] ['line']   = 'default: line not generated from input'
kb2tailor ['e'] = {}
kb2tailor ['e'] ['module'] = 'epu2event4xi5test.py'
kb2tailor ['e'] ['dragon'] = 'epu'
kb2tailor ['e'] ['DRAGON'] = 'EPU'
kb2tailor ['e'] ['line']   = 'default: line not generated from input'
kb2tailor ['f'] = {}
kb2tailor ['f'] ['module'] = 'fpu2event4xi5test.py'
kb2tailor ['f'] ['dragon'] = 'fpu'
kb2tailor ['f'] ['DRAGON'] = 'FPU'
kb2tailor ['f'] ['line']   = 'default: line not generated from input'
kb2tailor ['g'] = {}
kb2tailor ['g'] ['module'] = 'gpu2event4xi5test.py'
kb2tailor ['g'] ['dragon'] = 'gpu'
kb2tailor ['g'] ['DRAGON'] = 'GPU'
kb2tailor ['g'] ['line']   = 'default: line not generated from input'
kb2tailor ['h'] = {}
kb2tailor ['h'] ['module'] = 'hpu2event4xi5test.py'
kb2tailor ['h'] ['dragon'] = 'hpu'
kb2tailor ['h'] ['DRAGON'] = 'HPU'
kb2tailor ['h'] ['line']   = 'default: line not generated from input'
kb2tailor ['i'] = {}
kb2tailor ['i'] ['module'] = 'ipu2event4xi5test.py'
kb2tailor ['i'] ['dragon'] = 'ipu'
kb2tailor ['i'] ['DRAGON'] = 'IPU'
kb2tailor ['i'] ['line']   = 'default: line not generated from input'
kb2tailor ['j'] = {}
kb2tailor ['j'] ['module'] = 'jpu2event4xi5test.py'
kb2tailor ['j'] ['dragon'] = 'jpu'
kb2tailor ['j'] ['DRAGON'] = 'JPU'
kb2tailor ['j'] ['line']   = 'default: line not generated from input'
kb2tailor ['k'] = {}
kb2tailor ['k'] ['module'] = 'kpu2event4xi5test.py'
kb2tailor ['k'] ['dragon'] = 'kpu'
kb2tailor ['k'] ['DRAGON'] = 'KPU'
kb2tailor ['k'] ['line']   = 'default: line not generated from input'
kb2tailor ['l'] = {}
kb2tailor ['l'] ['module'] = 'lpu2event4xi5test.py'
kb2tailor ['l'] ['dragon'] = 'lpu'
kb2tailor ['l'] ['DRAGON'] = 'LPU'
kb2tailor ['l'] ['line']   = 'default: line not generated from input'
kb2tailor ['m'] = {}
kb2tailor ['m'] ['module'] = 'mpu2event4xi5test.py'
kb2tailor ['m'] ['dragon'] = 'mpu'
kb2tailor ['m'] ['DRAGON'] = 'MPU'
kb2tailor ['m'] ['line']   = 'default: line not generated from input'
kb2tailor ['n'] = {}
kb2tailor ['n'] ['module'] = 'npu2event4xi5test.py'
kb2tailor ['n'] ['dragon'] = 'npu'
kb2tailor ['n'] ['DRAGON'] = 'NPU'
kb2tailor ['n'] ['line']   = 'default: line not generated from input'
kb2tailor ['o'] = {}
kb2tailor ['o'] ['module'] = 'opu2event4xi5test.py'
kb2tailor ['o'] ['dragon'] = 'opu'
kb2tailor ['o'] ['DRAGON'] = 'OPU'
kb2tailor ['o'] ['line']   = 'default: line not generated from input'
kb2tailor ['p'] = {}
kb2tailor ['p'] ['module'] = 'ppu2event4xi5test.py'
kb2tailor ['p'] ['dragon'] = 'ppu'
kb2tailor ['p'] ['DRAGON'] = 'PPU'
kb2tailor ['p'] ['line']   = 'default: line not generated from input'
kb2tailor ['q'] = {}
kb2tailor ['q'] ['module'] = 'qpu2event4xi5test.py'
kb2tailor ['q'] ['dragon'] = 'qpu'
kb2tailor ['q'] ['DRAGON'] = 'QPU'
kb2tailor ['q'] ['line']   = 'default: line not generated from input'
kb2tailor ['r'] = {}
kb2tailor ['r'] ['module'] = 'rpu2event4xi5test.py'
kb2tailor ['r'] ['dragon'] = 'rpu'
kb2tailor ['r'] ['DRAGON'] = 'RPU'
kb2tailor ['r'] ['line']   = 'default: line not generated from input'
kb2tailor ['s'] = {}
kb2tailor ['s'] ['module'] = 'spu2event4xi5test.py'
kb2tailor ['s'] ['dragon'] = 'spu'
kb2tailor ['s'] ['DRAGON'] = 'SPU'
kb2tailor ['s'] ['line']   = 'default: line not generated from input'
kb2tailor ['t'] = {}
kb2tailor ['t'] ['module'] = 'tpu2event4xi5test.py'
kb2tailor ['t'] ['dragon'] = 'tpu'
kb2tailor ['t'] ['DRAGON'] = 'TPU'
kb2tailor ['t'] ['line']   = 'default: line not generated from input'
kb2tailor ['u'] = {}
kb2tailor ['u'] ['module'] = 'upu2event4xi5test.py'
kb2tailor ['u'] ['dragon'] = 'upu'
kb2tailor ['u'] ['DRAGON'] = 'UPU'
kb2tailor ['u'] ['line']   = 'default: line not generated from input'
kb2tailor ['v'] = {}
kb2tailor ['v'] ['module'] = 'vpu2event4xi5test.py'
kb2tailor ['v'] ['dragon'] = 'vpu'
kb2tailor ['v'] ['DRAGON'] = 'VPU'
kb2tailor ['v'] ['line']   = 'default: line not generated from input'
kb2tailor ['w'] = {}
kb2tailor ['w'] ['module'] = 'wpu2event4xi5test.py'
kb2tailor ['w'] ['dragon'] = 'wpu'
kb2tailor ['w'] ['DRAGON'] = 'WPU'
kb2tailor ['w'] ['line']   = 'default: line not generated from input'
kb2tailor ['x'] = {}
kb2tailor ['x'] ['module'] = 'xpu2event4xi5test.py'
kb2tailor ['x'] ['dragon'] = 'xpu'
kb2tailor ['x'] ['DRAGON'] = 'XPU'
kb2tailor ['x'] ['line']   = 'default: line not generated from input'
kb2tailor ['y'] = {}
kb2tailor ['y'] ['module'] = 'ypu2event4xi5test.py'
kb2tailor ['y'] ['dragon'] = 'ypu'
kb2tailor ['y'] ['DRAGON'] = 'YPU'
kb2tailor ['y'] ['line']   = 'default: line not generated from input'
kb2tailor ['z'] = {}
kb2tailor ['z'] ['module'] = 'zpu2event4xi5test.py'
kb2tailor ['z'] ['dragon'] = 'zpu'
kb2tailor ['z'] ['DRAGON'] = 'ZPU'
kb2tailor ['z'] ['line']   = 'default: line not generated from input'

                                                                                                    
    
ack2define = True
kb2keep = {}
if ack2define is False:
    # ------------------------------------------------------------------------------------------------------------------
    # TAILOR
    # ------------------------------------------------------------------------------------------------------------------
    kb2keep[1] = "ala loyda"
else:
    # ------------------------------------------------------------------------------------------------------------------
    # KEEP
    # ------------------------------------------------------------------------------------------------------------------
    kb2keep[1] = "#<dragonize4xi dragonization = "    # xml tag inside programs
    kb2keep[2] = "dragonxi.png"                       # dragon logo
    kb2keep[3] = "PROGRAM DRAGONXI"
    kb2keep[4] = "path2dragon"                     


path2read4xi  = VersionKB4Xi['input2generate4scope']  # walked folder
path2write4xi = VersionKB4Xi['output2generate4scope'] # put    folder with all subfolders a ... z

PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<define4xi definition = "
profile2fetch = '.py'                        # Python programs to be fetched
                                             # Extensions: '.txt'= text '.py'=Python, '.cpp'=C++, '.hpp'=headers, '.c'=C

#"
#/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
         #'generate2event4scope': 'NACK4XI'                      # NACK4XI = NOT TESTED <=> TRACE IT!
        }                              
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
#</function4xi>           

      
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print2trace4studio" usage = "
#   print XML trace
#"> 
# -------------------------------------------------------------------------------------------------    
def print2trace4xi(t2xi):

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
      
    event2sense = {
     'file_path4xi': '..//..//..//..//web//xml//sense-generate2event4scope.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/sw4xi/python33/owl/multiprocessing4dragon.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with event.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing generate2event4scope.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">generate2event4scope sensed.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, event2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    event2reason = {
     'file_path4xi': '..//..//..//..//web//xml//reason-generate2event4scope.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/sw4xi/python33/owl/multiprocessing4dragon.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for generate2event4scope.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with event.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, event2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    event2ace = {
     'file_path4xi': '..//..//..//..//web//xml//ace-generate2event4scope.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/sw4xi/python33/owl/multiprocessing4dragon.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for generate2event4scope.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of generate2event4scope.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, event2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print2trace4studio                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "generate2event4scope" usage = "
#   generates defined events to become master modules for OpenCL events
#"> 
# -------------------------------------------------------------------------------------------------
def generate2event4scope(program2explore):
    global kb2keep                               
    global kb2tailor                             
    global kb2write  
    
    global path2read4xi                          # path for input source programs
    global path2write4xi                         # path for output source programs
    global profile2fetch                         # extension for files
        
    class2print  = "generate2event4scope"
    method2print = "generate2event4scope" 
    # message2print = "{(Step 0A/33) using" + "; t2xi-using-by-generate2event4scope: " + str(t2xi)  + "; time: " + time4xi() + "}"
    # print4xi(class2print, method2print, message2print)         
    # <print4xi.Print4Xi object at 0x00000000032DFFD0>
    
    message2print = "{(Step 0B/33) got" + "; program2explore-got-by-generate2event4scope: " + str(program2explore)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # L://job//041721//studio4xi//cc//generate//in//lib//dragon//dragon2event4xi.py
               
    # ---------------------------------------------------------------------------------------------
    # SPLIT PROGRAM NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2program=os.path.splitext(program2explore)
    
    if name2program[1] == profile2fetch:          
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF GENERATE2SCOPE4XI - IS PYTHON PROGRAM
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 1A/33) analyzing" + "; program2explore-analyzing-by-generate2event4scope: " + str(program2explore) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        # L://job//041721//studio4xi//cc//generate//in//lib//dragon//dragon2event4xi.py
        
      
        path2input = name2program[0] + profile2fetch 
        # message2print = "{(Step 1B/33) set" + "; path2input-set-by-generate2event4scope to: " + str(path2input)  + "; time: " + time4xi() + "}"
        # print4xi(class2print, method2print, message2print)          
        # L://job//041721//studio4xi//cc//generate//in//lib//dragon//dragon2event4xi.py
         
        # -----------------------------------------------------------------------------------------
        # (Step 2/33) OF GENERATE2SCOPE4XI - OPEN INPUT FILE
        # -----------------------------------------------------------------------------------------
        file2input = open(path2input,'r')
        message2print = "{(Step 2A/33) opened" + "; file2input-opened-by-generate2event4scope: " + str(file2input) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        # <_io.TextIOWrapper name='L://job//041721//studio4xi//cc//generate//in//lib//dragon//dragon2event4xi.py' mode='r' encoding='cp1252'>
  
        # -----------------------------------------------------------------------------------------
        # (Step 3/33) OF GENERATE2SCOPE4XI - OPEN NECESSARY OUTPUT FILES
        # -----------------------------------------------------------------------------------------        
        keys2output = kb2tailor.keys()                                                                            # ... z (a<=>apu ... z<=>zpu in scope4xi library)
        message2print = "{(Step 3A/33) set" + "; keys2output-set-by-generate2event4scope to: " + str(keys2output) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        # dict_keys(['h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'x'
        program2write = None
        try:
            for key2output in keys2output: 
                                                                                                                                                                                      
                # -------------------------------------------------------------------------------------
                # (Step 3A/33) OF GENERATE2SCOPE4XI - MODULE
                # -------------------------------------------------------------------------------------                        
                program2write = kb2tailor [key2output] ['module']                                                     # ... [z] = 'zpu2event4xi.py' 
                if ActKB4scope [key2output] ['generate2event4scope'] == 'ACK':                                        # ActKB4scope ['z'] ['generate2event4scope'] = 'ACK'
                
                        
                    path2write4program = path2write4xi + key2output + '//' + program2write                            # ... L://job//041721//studio4xi//cc//generate//out//lib//z//zpu2event4xi.py
                        
                    message2print = "{(Step 3A/33) set" + "; path2write4program-set-by-generate2event4scope to: " + str(path2write4program)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
                    # L://job//041721//studio4xi//cc//generate//out//lib//z//zpu2event4xi.py
                     
                                           
                    # -----------------------------------------------------------------------------------------
                    # (Step 3B/33) OF GENERATE2SCOPE4XI - OPEN OUTPUT FOR DEVICE MODULE TO BE GENERATED(ONCE)
                    # -----------------------------------------------------------------------------------------
                    kb2write [key2output] = open(path2write4program,'w')                                                              
                    message2print = "{(Step 3B/33) opened" + "; file2output-opened-by-generate2event4scope: " + str(kb2write [key2output]) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)              
                    # <_io.TextIOWrapper name='L://job//041721//studio4xi//cc//generate//out//lib//z//zpu2event4xi.py' mode='w' encoding='cp1252'>
                    
                else:
                    message2print = "{(Step 3Y/33) skipped" + "; program2write-skipped-by-generate2event4scope: " + str(program2write)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                      
                    # xpu2event4xi.py ... xpu2event4xi.py
        except:
            message2print = "{(Step 3Z/33) failed" + "; program2write-failed-by-generate2event4scope: " + str(program2write) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)     
            # 
                               
        # -----------------------------------------------------------------------------------------
        # (Step 4/33) OF GENERATE2SCOPE4XI - PROCESS INPUT FILE
        # -----------------------------------------------------------------------------------------                        
        while 1:
            # -------------------------------------------------------------------------------------
            # (Step 5/33) OF GENERATE2SCOPE4XI - LINE OF SOURCE FILE OF VIRTUAL DEVICE 
            # -------------------------------------------------------------------------------------             
            line2process = file2input.readline()
            message2print = "{(Step 5A/33) got" + "; line2process-got-by-generate2event4scope: " + str(line2process)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # #<profile4xi profile = "12" />
            if not line2process:
                # ---------------------------------------------------------------------------------
                # (Step 5A/33) OF DRAGONIZE2SCOPE4XI - ALL LINES READ, FINISH
                # ---------------------------------------------------------------------------------             
                break                                               
            else:
                
                # ---------------------------------------------------------------------------------
                # (Step 5B/33) OF GENERATE2SCOPE4XI - CHECK LINE CONTENT AND CORRECT IF NECESSARY
                # ---------------------------------------------------------------------------------   
                string2fake    = "dragonized"
                string2replace = "modernized"
                
                index2fake = str.find(line2process,string2fake)
                if index2fake == -1:
                    pass
                else:
                    message2print = "{(Step 5C/33) hunted" + "; dragonized-hunted-by-generate2scope4xi: " + str(line2process)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # 'manoeuvre2copyprogram4dragon',             # ACK dragonized
                    
                    line2process = line2process[0:index2fake:] + string2replace + line2process[index2fake+len(string2fake):]
                            
                    message2print = "{(Step 5D/33) set" + "; line2process-set-by-generate2scope4xi to: " + str(line2process)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # 'manoeuvre2copyprogram4dragon',             # ACK modernized

            
                # ------------------------------------------------------------------------------------------------
                # (Step 5E/33) OF GENERATE2SCOPE4XI - POPULATE LINE FOR REQUIRED DEVICES INTO RAM TABLE
                # ------------------------------------------------------------------------------------------------
                key2populate = None
                try:
                    keys2populate = kb2tailor.keys()
                    for key2populate in sorted(keys2populate):
                        if ActKB4scope [key2populate] ['generate2event4scope'] == 'ACK':
                            kb2tailor[key2populate] ['line'] = line2process
                    
                            message2print = "{(Step 5E/33) set" + "; line2event-set-by-generate2scope4xi to: " + str(kb2tailor[key2populate] ['line'])  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            # #<profile4xi profile = "12" />  
                            # 
                        else:
                            message2print = "{(Step 5Y/33) skipped" + "; key2populate-skipped-by-generate2scope4xi: " + str(key2populate)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)                      
                            # a ... y
                except:
                    message2print = "{(Step 5ZZ/33) failed" + "; kb2populate-failed-by-generate2scope4xi: " + str(kb2populate) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    #
                    
                # ------------------------------------------------------------------------------------------------
                # (Step 7E/33) OF GENERATE2SCOPE4XI - PROCESS RAM TABLE - DO NOT USE LINE READ FROM FILE ANYMORE!
                # ------------------------------------------------------------------------------------------------                               
                
                keys2tailor = kb2tailor.keys()
                for key2tailor in sorted(keys2tailor):
                    if ActKB4scope [key2tailor] ['generate2event4scope'] == 'ACK':
                        # -------------------------------------------------------------------------------------
                        # (Step 5/33) OF GENERATE2SCOPE4XI - PROCESS ONE LINE OF SOURCE FILE OF VIRTUAL DEVICE 
                        # -------------------------------------------------------------------------------------   
                        ack2tailor = False                                               # default no tailoring
                        ack2except = False                                               # default no exception
                        keys2keep = kb2keep.keys()
                        for key2keep in keys2keep:
                            index2keep = str.find(kb2tailor [key2tailor] ['line'], kb2keep[key2keep])
                            if index2keep == -1:
                                pass
                            else:
                                # -----------------------------------------------------------------------------------
                                # PROTECTED STRING SUCH AS PROGRAM TAG 
                                # -----------------------------------------------------------------------------------
                                ack2except = True
                                message2print = "{(Step 5B/33) set" + "; ack2except-set-by-generate2scope4xi to: " + str(ack2except)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # 
                                
                        message2print = "{(Step 5B/33) using" + "; ack2except-using-by-generate2scope4xi: " + str(ack2except)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)    
                        # 
                        message2print = "{(Step 5C/33) using" + "; ack2tailor-using-by-generate2scope4xi: " + str(ack2tailor)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)    
                        #                 
                                 
                        # -------------------------------------------------------------------------------------
                        # CONTINUE AFTER HAVING CHECKED WHETHER LINE MUST BE PROTECTED OF TAILORING
                        # -------------------------------------------------------------------------------------                 
                        
                        keys2search = kb2search.keys()                                 
                        for key2search in sorted(keys2search):
                            # ------------------------------------------------------------------------------------
                            # PATTERN SEARCH IN LINE
                            # ------------------------------------------------------------------------------------                        
                            message2print = "{(Step 7A/33) using" + "; key2search-using-by-generate2event4scope: " + str(key2search)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)      
                            # 1;  
                            
                            kb2pattern = kb2search[key2search]                        
                            keys2pattern = kb2pattern.keys()                         
                            
                                        
                            for key2pattern in sorted(keys2pattern):                  
                                message2print = "{(Step 7C/33) using" + "; key2pattern-using-by-generate2event4scope: " + str(key2pattern)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)      
                                # 1;
          
                                # -------------------------------------------------------------------------------------
                                # (Step 8/33) OF DRAGONIZE2SCOPE4XI - LOOK FOR VIRTUAL DRAGON DEVICE  
                                # -------------------------------------------------------------------------------------                            
                                string2look = kb2search[key2search] [key2pattern]                                                              
                                message2print = "{(Step 8A/33) using" + "; string2look-using-by-generate2scope4xi: " + str(string2look)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)
                                # dragon
    
                                line2look = kb2tailor [key2tailor] ['line']
                                
                                message2print = "{(Step 8B/33) set" + "; line2look-set-by-generate2scope4xi to: " + str(line2look)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)  
                                # #<profile4xi profile = "12" />
                                
                               
                                message2print = "{(Step 8D/33) using" + "; string2look-using-by-generate2scope4xi: " + str(string2look)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)
                                # dragon
                                                           
                                index2look = str.find(line2look,string2look)
                                
                                message2print = "{(Step 8E/33) set" + "; index2look-set-by-generate2scope4xi to: " + str(index2look)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)  
                                # -1                            
                                                                         
                                 
                                message2print = "{(Step 8C/33) set" + "; index2look-set-by-generate2scope4xi to: " + str(index2look)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)  
                                # -1
                                
                                              
                                if index2look == -1: 
                                    # --------------------------------------------------------------------------------------------------------------
                                    # (Step 9/33) OF DRAGONIZE2SCOPE4XI - DRAGON DEVICE NOT FOUND IN LINE (MAY NOT BE THERE ANYMORE DUE TO TAILORING)
                                    # --------------------------------------------------------------------------------------------------------------                                         
                                    message2print = "{(Step 9A/33) ignored" + "; line-ignored-by-generate2scope4xi: " + str(line2look) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)  
                                    # #<profile4xi profile = "12" />
                                    message2print = "{(Step 9B/33) ignored" + "; key2tailor-ignored-by-generate2scope4xi: " + str(key2tailor) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)  
                                    # c                                
                                else:
                                    # -----------------------------------------------------------------------------------
                                    # (Step 10/33) OF DRAGONIZE2SCOPE4XI - VIRTUAL DEVICE DRAGON FOUND
                                    # -----------------------------------------------------------------------------------                                                                                   
                                    message2print = "{(Step 10A/33) hunted" + "; line-hunted-by-generate2scope4xi: " + str(kb2tailor [key2tailor] ['line'])  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # #<program4xi program = "dragon2event4xi.py">
                                    # 
    
                                    if ack2except is False:                               
                                        # -----------------------------------------------------------------
                                        # (STEP 11/33) OF DRAGONIZE2SCOPE4XI - TAILOR IT 
                                        # -----------------------------------------------------------------                                    
                                        message2print = "{(Step 11A/33) using" + "; index2look-using-by-generate2scope4xi: " + str(index2look)  + "; time: " + time4xi() + "}"
                                        print4xi(class2print, method2print, message2print) 
                                        # 24 
                                
                                        try:  
                                            # -----------------------------------------------------------------
                                            # (STEP 11/33) OF DRAGONIZE2SCOPE4XI - TAILOR IT FOR THIS DEVICE
                                            # -----------------------------------------------------------------                                     
                                            message2print = "{(Step 11T1/33) using" + "; key2tailor-using-by-generate2scope4xi: " + str(key2tailor)  + "; time: " + time4xi() + "}"
                                            print4xi(class2print, method2print, message2print)
                                            #  z 
    
                                            line2tailor = kb2tailor [key2tailor] ['line']
                                            message2print = "{(Step 11T2/33) upgrading" + "; line2tailor-by-generate2scope4xi: " + str(line2tailor)  + "; time: " + time4xi() + "}"
                                            print4xi(class2print, method2print, message2print)
                                            # #<program4xi program = "dragon2event4xi.py">
                                            
                                            message2print = "{(Step 11T3/33) using" + "; string2look-using-by-generate2scope4xi: " + str(string2look)  + "; time: " + time4xi() + "}"
                                            print4xi(class2print, method2print, message2print)
                                            # dragon
                                                                                            
                                            index2tailor = str.find(line2tailor,string2look)
                                            message2print = "{(Step 11T4/33) using" + "; index2tailor-using-by-generate2scope4xi: " + str(index2tailor)  + "; time: " + time4xi() + "}"
                                            print4xi(class2print, method2print, message2print)
                                            #                                            
                                                
                                            message2print = "{(Step 11T5/33) using" + "; begin-using-by-generate2scope4xi: " + str(line2tailor[0:index2tailor:])  + "; time: " + time4xi() + "}"
                                            print4xi(class2print, method2print, message2print)
                                            #                                            
                                                
                                            message2print = "{(Step 11T6/33) using" + "; middle-using-by-generate2scope4xi: " + str(kb2tailor [key2tailor] [string2look])  + "; time: " + time4xi() + "}"
                                            print4xi(class2print, method2print, message2print)
                                            #                                              
                                                
                                            message2print = "{(Step 11T7/33) using" + "; end-using-by-generate2scope4xi: " + str(line2tailor[index2tailor+len(string2look):])  + "; time: " + time4xi() + "}"
                                            print4xi(class2print, method2print, message2print)
                                            #
    
    
                                            # ===============================================================================================================================================================
                                            # TAILOR THIS DEVICE LINE IN RAM 
                                            # ===============================================================================================================================================================
                                            kb2tailor[key2tailor] ['line'] = line2tailor[0:index2tailor:] + str(kb2tailor [key2tailor] [string2look]) + line2tailor[index2tailor+len(string2look):]
                                            #                                                                  kb2tailor ['a'] ['dragon'] = 'apu'
                                            
                                            message2print = "{(Step 11T8/33) upgraded" + "; element-upgraded-by-generate2scope4xi to: " + str(kb2tailor[key2tailor] ['line'])  + "; time: " + time4xi() + "}"
                                            print4xi(class2print, method2print, message2print)
                                            # #<program4xi program = "zpu2event4xi.py"> 
                                            # #<abstract4xi abstract = "APU 2D event management"/>
                                            # ...
                                            # #<abstract4xi abstract = "ZPU 2D event management"/>
                                                 
                                            ack2tailor = True
                                            

                                            # ---------------------------------------------------------------------------------
                                            # CONTINUE AFTER HAVING TAILORED LINE
                                            # ---------------------------------------------------------------------------------
                                                                                                                                                                                                                                     
                                        except:
                                            message2print = "{(Step 11Z/33) failed" + "; tailoring-failed-by-generate2scope4xi: " + str(kb2tailor [key2tailor] ['line']) + "; time: " + time4xi() + "}"
                                            print4xi(class2print, method2print, message2print)
                                            #
                                        # -------------------------------------------------------------------------------------
                                        # CONTINUE AFTER HAVING TRIED TO TAILOR RAM LINE FOR EVERY DEVICE 
                                        # ------------------------------------------------------------------------------------- 
                                        pass 
                                    else:
                                        # -------------------------------------------------------------------------------------
                                        # LINE MIGHT BE PROTECTED OR HAS ALREADY BE TAILORED AS MUCH AS NEEDED 
                                        # ------------------------------------------------------------------------------------- 
                                        pass
                                    
                                # ---------------------------------------------------------------------------------------------
                                # EOF VIRTUAL DEVICE LINE  
                                # ---------------------------------------------------------------------------------------------
                                message2print = "{(Step 20A/33) performed" + "; look2virtual4line-performed-by-generate2scope4xi: " + str(line2process)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)
                                ##<profile4xi profile = "12" /> 
         
                                # -----------------------------------------------------------------------------------------
                                # CONTINUE AFTER HAVING SEARCHED WITH ONE PATTERN  
                                # -----------------------------------------------------------------------------------------
                                if ack2tailor is True:
    
                                    message2print = "{(Step 20B/33) using" + "; line2tailor-using-by-generate2scope4xi: " + str(line2process)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    #
                                    ack2tailor = False
                                else:
                                    message2print = "{(Step 20C/33) skipped" + "; line2tailor-skipped-by-generate2scope4xi: " + str(line2process)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)                      
                                    #<profile4xi profile = "12" />
                                
                                message2print = "{(Step 20D/33) performed" + "; search2pattern-performed-by-generate2scope4xi: " + str(line2process) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)
                                #<profile4xi profile = "12" />
                                    
                            # --------------------------------------------------------------------------------------------------
                            # CONTINUE AFTER HAVING GONE THROUGH ALL PATTERNS
                            # --------------------------------------------------------------------------------------------------
                            message2print = "{(Step 21A/33) performed" + "; search2patterns-performed-by-generate2scope4xi: " + str(line2process) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)    
                            #<profile4xi profile = "12" />
                                                                  
                        # ------------------------------------------------------------------------------------------------------
                        # CONTINUE WITH LINE - WHICH MAY HAVE GONE THROUGH TAILORING AND COPY OF WHICH IS IN RAM FOR EACH DEVICE 
                        # ------------------------------------------------------------------------------------------------------            
                        message2print = "{(Step 28A/33) performed" + "; line-performed-by-generate2scope4xi: " + str(line2process) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # #<profile4xi profile = "12" /> <-- should be in RAM!
    
                                
                        # ----------------------------------------------------------------------------------
                        # CONTINUE AFTER THE LINE OF VIRTUAL DEVICE HAS BEEN WRITTEN TO FILES OF ALL DEVICES 
                        # ----------------------------------------------------------------------------------
                        message2print = "{(Step 28I/33) performed" + "; writing2files-performed-by-generate2scope4xi: " + str(kb2tailor [key2tailor] ['line']) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # #<profile4xi profile = "12" />
                        #                 

                        message2print = "{(Step 29A/33) performed" + "; process2line-performed-by-generate2scope4xi: " + str(file2input) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # #<profile4xi profile = "12" />
                                                                               
                        # --------------------------------------------------------------------------------------------------
                        # (Step 30/33) OF GENERATE2SCOPE4XI - WRITE LINE TO OPEN FILES FROM RAM TAILORED FOR EACH DEVICE
                        # --------------------------------------------------------------------------------------------------         
                        message2print = "{(Step 29B/33) using" + "; keys2tailor-using-by-generate2scope4xi: " + str(keys2tailor)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #                   
                        try:
                            keys2job = kb2tailor.keys()
                            for key2job in sorted(keys2job):
                                if ActKB4scope [key2job] ['generate2event4scope'] == 'ACK': 
                                    file2output = kb2write [key2job]
                                    message2print = "{(Step 29C/33) using" + "; file2output-using-by-generate2scope4xi: " + str(file2output)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # 
                                                        
                                    file2output.write(kb2tailor [key2job] ['line'] )
                                    
                                    message2print = "{(Step 29H/33) wrote" + "; line-wrote-by-generate2scope4xi: " + str(kb2tailor [key2job] ['line']) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    #
                                else:
                                    message2print = "{(Step 29H/33) skipped" + "; key2tailor-skipped-by-generate2scope4xi: " + str(key2job)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)                      
            
                        except:
                            message2print = "{(Step 29Z1/33) failed" + "; write-failed-by-generate2scope4xi: " + str(kb2job) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            #
                    else:
                        message2print = "{(Step 29Z2/33) skipped" + "; key2tailor-skipped-by-generate2scope4xi: " + str(key2tailor)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)                                                                     
                
                
            # -------------------------------------------------------------------------------------
            # CONTINUE AFTER PROCESSED RAM TABLE FOR DEVICES
            # -------------------------------------------------------------------------------------                                          

                             
    else:
        # -----------------------------------------------------------------------------------------
        # INPUT FILE IS NOT PYTHON PROGRAM (THIS THE ONLY CHECK FOR INPUT)
        # -----------------------------------------------------------------------------------------       
        message2print = "{(Step 1B/33) skipped" + "; program2explore-skipped-by-generate2event4scope: " + str(program2explore)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  

                
    # -----------------------------------------------------------------------------------------
    # CONTINUE AFTER HAVING HANDLED INPUT FILE - WHATEVER IT WAS
    # -----------------------------------------------------------------------------------------        
    message2print = "{(Step 29A/33) performed" + "; input-performed-by-generate2scope4xi: " + str(file2input) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # <_io.TextIOWrapper name='L://job//041721//studio4xi//cc//generate//in//lib//dragon//dragon2event4xi.py' mode='r' encoding='cp1252'>             

                       
                       
    # -----------------------------------------------------------------------------------------
    # (Step 30/33) OF GENERATE2SCOPE4XI - CLOSE NECESSARY OUTPUT FILES
    # -----------------------------------------------------------------------------------------
    keys2write = kb2write.keys()                                           
    for key2write in keys2write:                                                                   
        if ActKB4scope [key2write] ['generate2event4scope'] == 'ACK':   
            file2close = kb2write [key2write]                                                        
            file2close.close()
        
            message2print = "{(Step 30A/33) closed" + "; file2close-closed-by-generate2event4scope: " + str(file2close) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # <_io.TextIOWrapper name='L://job//041721//studio4xi//cc//generate//out//lib//a//apu2event4xi.py' mode='w' encoding='cp1252'>
            # ...
            # <_io.TextIOWrapper name='L://job//041721//studio4xi//cc//generate//out//lib//z//zpu2event4xi.py' mode='w' encoding='cp1252'> 
        else:
            message2print = "{(Step 30Y/33) skipped" + "; key2write-skipped-by-generate2event4scope: " + str(key2write)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                      
                                 

            
    # ---------------------------------------------------------------------------------
    # (Step 31/33) OF GENERATE2SCOPE4XI - CLOSE ONE INPUT FILE
    # ---------------------------------------------------------------------------------                
    file2input.close()
    
    message2print = "{(Step 31A/33) performed" + "; close2input-performed-by-generate2scope4xi: " + str(file2input) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # <_io.TextIOWrapper name='L://job//041721//studio4xi//cc//generate//in//lib//dragon//dragon2event4xi.py' mode='r' encoding='cp1252'>
                    
    # -----------------------------------------------------------------------------------------
    # (Step 32/33) OF GENERATE2SCOPE4XI - STATUS
    # -----------------------------------------------------------------------------------------        
    keys2status = kb2tailor.keys()
    for key2status in sorted(keys2status):
        message2print = "{(Step 32/33) used" + "; tailoring-used-by-generate2scope4xi: " + str(kb2tailor[key2status])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #      
        
    # -----------------------------------------------------------------------------------------
    # RETURN
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 33C/33) returning" + "; generate2event4scope-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                      
        
    # ---------------------------------------------------------------------------------------------
    # EOF FUNCTION
    # ---------------------------------------------------------------------------------------------                                   
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   reviewing all tests
#">                           
# -------------------------------------------------------------------------------------------------
def main():
  
    global path2read4xi
    global path2write4xi
    global profile2fetch

    global t2xi
    global trace_object_count    
        
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
    
    try:
    
        # --------------------------------------------------------------------------------------------- 
        # (Step 1/33) OF MAIN GENERATE2SCOPE4XI - START
        # ---------------------------------------------------------------------------------------------
        print("(Step 1A/33) OF MAIN GENERATE2SCOPE4XI - STARTED ", time4xi())
        # <print4xi.Print4Xi object at 0x00000000032DB710>         
        print("(Step 1B/33) OF MAIN GENERATE2SCOPE4XI - PATH2READ4XI: ", path2read4xi)
        # L://job//041721//studio4xi//cc//generate//in//lib//dragon//
        print("(Step 1C/33) OF MAIN GENERATE2SCOPE4XI - PATH2WRITE4XI: ", path2write4xi)
        # L://job//041721//studio4xi//cc//generate//out//lib//
                
        # --------------------------------------------------------------------------------------------- 
        # (Step 2/33) OF MAIN GENERATE2SCOPE4XI - WALK
        # ---------------------------------------------------------------------------------------------   
        for file2walk in DirectoryWalker(path2read4xi):
            # ----------------------------------------------------------------------------------------- 
            #
            # -----------------------------------------------------------------------------------------     
            if os.path.isdir(file2walk):
                print ("(Step 3A/33) OF MAIN GENERATE2SCOPE4XI - WALKING DIRECTORY: ", file2walk)
                # 
            if os.path.isfile(file2walk):
                print("(Step 3B/33) OF MAIN GENERATE2SCOPE4XI - FILE TO WALK: ", file2walk)
                # L://job//041721//studio4xi//cc//generate//in//lib//dragon//dragon2event4xi.py
                generate2event4scope(file2walk)


        # -------------------------------------------------------------------------------------------
        # (Step 4/33) OF MAIN GENERATE2SCOPE4XI - FINISH
        # -------------------------------------------------------------------------------------------
        print("(Step 4A/33) OF MAIN GENERATE2SCOPE4XI - FINISHED ", time4xi())
        # 
        
    except:
        print("(Step 13/33) OF MAIN GENERATE2SCOPE4XI *** FAILED *** ", time4xi())          
    
    finally: 
        # ---------------------------------------------------------------------------------------------    
        # FINALLY PRINT TRACE WHATEVER HAPPENS
        # ---------------------------------------------------------------------------------------------     
        print2trace4xi(t2xi)        
      
    
#</function4xi>
    
        
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()        
#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# L:\job\041721\studio4xi\cc\generate\out\txt\generate2event4scope.txt
# L:\job\041721\studio4xi\cc\generate\out\xml\ace-generate2event4scope.xml
# L:\job\041721\studio4xi\cc\generate\out\xml\reason-generate2event4scope.xml
# L:\job\041721\studio4xi\cc\generate\out\xml\sense-generate2event4scope.xml
#"
#>
#     
# 
# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of generate2event4scope.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

